"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Pedigree(ProtocolElement):
    """
    This is the concept of a family with associated phenotypes as present
    in the record RDParticipant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "familyId",
        "members",
        "readyForAnalysis",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "analysisPanels": participant_1_0_1.AnalysisPanel,
            "diseasePenetrances": participant_1_0_1.DiseasePenetrance,
            "members": participant_1_0_1.PedigreeMember,
            "versionControl": participant_1_0_1.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "familyQCState": participant_1_0_1.FamilyQCState,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_1 import participant as participant_1_0_1

        return {
            "org.gel.models.participant.avro.AnalysisPanel": participant_1_0_1.AnalysisPanel,
            "org.gel.models.participant.avro.DiseasePenetrance": participant_1_0_1.DiseasePenetrance,
            "org.gel.models.participant.avro.FamilyQCState": participant_1_0_1.FamilyQCState,
            "org.gel.models.participant.avro.PedigreeMember": participant_1_0_1.PedigreeMember,
            "org.gel.models.participant.avro.VersionControl": participant_1_0_1.VersionControl,
            "org.gel.models.participant.avro.Pedigree": participant_1_0_1.Pedigree,
        }

    __slots__ = [
        "familyId",
        "members",
        "readyForAnalysis",
        "LDPCode",
        "analysisPanels",
        "diseasePenetrances",
        "familyQCState",
        "versionControl",
    ]

    def __init__(
        self,
        familyId,
        members,
        readyForAnalysis,
        LDPCode=None,
        analysisPanels=None,
        diseasePenetrances=None,
        familyQCState=None,
        versionControl=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_0_1.Pedigree model.

        :param familyId:
            Family id which internally translate to a sample set
        :type familyId: str
        :param members:
        :type members: list[PedigreeMember]
        :param readyForAnalysis:
        :type readyForAnalysis: boolean
        :param LDPCode:
        :type LDPCode: None | str
        :param analysisPanels:
        :type analysisPanels: None | list[AnalysisPanel]
        :param diseasePenetrances:
        :type diseasePenetrances: None | list[DiseasePenetrance]
        :param familyQCState:
        :type familyQCState: None | FamilyQCState
        :param versionControl:
            Model version number
        :type versionControl: None | VersionControl
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.1"
